/*
    Project: TCTEMP
    Version: V1.18
    File   : tc_priv.h

    Copyright (c) 2006-2009 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __TC_PRIV_H
#define __TC_PRIV_H

#include "tc.h"

#define TC_ASSERT(x)

#ifndef UNREFERENCED_PARAMETER
#  define UNREFERENCED_PARAMETER(P) (P)
#endif

extern const unsigned __int32 rgdwCRC32Table[256];
#define UpdateCRC(dwCRC, bData) \
    dwCRC = rgdwCRC32Table[(dwCRC ^ bData) & 0xff] ^ (dwCRC >> 8)
unsigned __int32 __stdcall GetCRC32(const void *pData, size_t nSize);


#define Reverse16(pDest) \
    do { \
        unsigned __int8 tmp; \
        unsigned __int8 *p = (unsigned __int8 *)pDest; \
        tmp = p[0]; \
        p[0] = p[1]; \
        p[1] = tmp; \
    } while (0)

#define Reverse32(pDest) \
    do { \
        unsigned __int8 tmp; \
        unsigned __int8 *p = (unsigned __int8 *)pDest; \
        tmp = p[0]; \
        p[0] = p[3]; \
        p[3] = tmp; \
        tmp = p[1]; \
        p[1] = p[2]; \
        p[2] = tmp; \
    } while (0)

#define Reverse64(pDest) \
    do { \
        unsigned __int8 tmp; \
        unsigned __int8 *p = (unsigned __int8 *)pDest; \
        tmp = p[0]; \
        p[0] = p[7]; \
        p[7] = tmp; \
        tmp = p[1]; \
        p[1] = p[6]; \
        p[6] = tmp; \
        tmp = p[2]; \
        p[2] = p[5]; \
        p[5] = tmp; \
        tmp = p[3]; \
        p[3] = p[4]; \
        p[4] = tmp; \
    } while (0)

#define Xor128(pDest, pSrc) \
    ((unsigned __int64 *)pDest)[0] ^= ((const unsigned __int64 *)pSrc)[0]; \
    ((unsigned __int64 *)pDest)[1] ^= ((const unsigned __int64 *)pSrc)[1]

#endif
